package net.locusworks.common.utils;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Base64;

import net.locusworks.common.Charsets;

public class DataOutputStreamHelper extends DataOutputStream implements AutoCloseable{

  public DataOutputStreamHelper() {
    this(new ByteArrayOutputStream());
  }
  
  public DataOutputStreamHelper(OutputStream out) {
    super(out);
  }
  
  public byte[] toByteArray() {
    if (super.out == null) {
      return new byte[0];
    }
    if (super.out instanceof ByteArrayOutputStream) {
      return ((ByteArrayOutputStream)super.out).toByteArray();
    }
    return super.out.toString().getBytes(Charsets.UTF_8);
  }
  
  public String base64Encoded() {
    return Base64.getEncoder().encodeToString(this.toByteArray());
  }
  
  @Override
  public String toString() {
   return new String(this.toByteArray(), Charsets.UTF_8);
  }
  
  @Override
  public void close() throws IOException {
   if (super.out != null) {
     try {
       super.out.close();
       super.out = null;
     } catch (Exception ex) {}
   }
  }

}
